function idx = findClosestCentroids(X, centroids)
  ##FINDCLOSESTCENTROIDS computes the centroid memberships for every example
  ##   idx = FINDCLOSESTCENTROIDS (X, centroids) returns the closest centroids
  ##   in idx for a dataset X where each row is a single example. idx = m x 1 
  ##   vector of centroid assignments (i.e. each entry in range [1..K])
  ##

  ## Set K
  K = rows (centroids);
  
  ## Using broadcasting (auto BSX) as available in Octave 3.5.0+
  d = sum ((permute (X, [1,3,2]) - permute (centroids, [3,1,2])).^2, 3);
  [~, idx] = min (d, [], 2);

endfunction

